__  __    __   __  _____      _            _          _____ _          _ _ 
 |  \/  |   \ \ / / |  __ \    (_)          | |        / ____| |        | | |
 | \  / |_ __\ V /  | |__) | __ ___   ____ _| |_ ___  | (___ | |__   ___| | |
 | |\/| | '__|> <   |  ___/ '__| \ \ / / _` | __/ _ \  \___ \| '_ \ / _ \ | |
 | |  | | |_ / . \  | |   | |  | |\ V / (_| | ||  __/  ____) | | | |  __/ | |
 |_|  |_|_(_)_/ \_\ |_|   |_|  |_| \_/ \__,_|\__\___| |_____/|_| |_|\___V 2.1
 if you need WebShell for Seo everyday contact me on Telegram
 Telegram Address : @jackleet
        
        
For_More_Tools: Telegram: @jackleet | Bulk Smtp support mail sender | Business Mail Collector | Mail Bouncer All Mail | Bulk Office Mail Validator | Html Letter private



Upload:

Command:

[email protected]: ~ $
#!/bin/bash
# SPDX-License-Identifier: GPL-2.0

ALL_TESTS="unreachable_chain_test gact_goto_chain_test create_destroy_chain \
	   template_filter_fits"
NUM_NETIFS=2
source tc_common.sh
source lib.sh

tcflags="skip_hw"

h1_create()
{
	simple_if_init $h1 192.0.2.1/24
}

h1_destroy()
{
	simple_if_fini $h1 192.0.2.1/24
}

h2_create()
{
	simple_if_init $h2 192.0.2.2/24
	tc qdisc add dev $h2 clsact
}

h2_destroy()
{
	tc qdisc del dev $h2 clsact
	simple_if_fini $h2 192.0.2.2/24
}

unreachable_chain_test()
{
	RET=0

	tc filter add dev $h2 ingress chain 1 protocol ip pref 1 handle 1101 \
		flower $tcflags dst_mac $h2mac action drop

	$MZ $h1 -c 1 -p 64 -a $h1mac -b $h2mac -A 192.0.2.1 -B 192.0.2.2 \
		-t ip -q

	tc_check_packets "dev $h2 ingress" 1101 1
	check_fail $? "matched on filter in unreachable chain"

	tc filter del dev $h2 ingress chain 1 protocol ip pref 1 handle 1101 \
		flower

	log_test "unreachable chain ($tcflags)"
}

gact_goto_chain_test()
{
	RET=0

	tc filter add dev $h2 ingress chain 1 protocol ip pref 1 handle 1101 \
		flower $tcflags dst_mac $h2mac action drop
	tc filter add dev $h2 ingress protocol ip pref 2 handle 102 flower \
		$tcflags dst_mac $h2mac action drop
	tc filter add dev $h2 ingress protocol ip pref 1 handle 101 flower \
		$tcflags dst_mac $h2mac action goto chain 1

	$MZ $h1 -c 1 -p 64 -a $h1mac -b $h2mac -A 192.0.2.1 -B 192.0.2.2 \
		-t ip -q

	tc_check_packets "dev $h2 ingress" 102 1
	check_fail $? "Matched on a wrong filter"

	tc_check_packets "dev $h2 ingress" 101 1
	check_err $? "Did not match on correct filter with goto chain action"

	tc_check_packets "dev $h2 ingress" 1101 1
	check_err $? "Did not match on correct filter in chain 1"

	tc filter del dev $h2 ingress protocol ip pref 1 handle 101 flower
	tc filter del dev $h2 ingress protocol ip pref 2 handle 102 flower
	tc filter del dev $h2 ingress chain 1 protocol ip pref 1 handle 1101 \
		flower

	log_test "gact goto chain ($tcflags)"
}

create_destroy_chain()
{
	RET=0

	tc chain add dev $h2 ingress
	check_err $? "Failed to create default chain"

	output="$(tc -j chain get dev $h2 ingress)"
	check_err $? "Failed to get default chain"

	echo $output | jq -e ".[] | select(.chain == 0)" &> /dev/null
	check_err $? "Unexpected output for default chain"

	tc chain add dev $h2 ingress chain 1
	check_err $? "Failed to create chain 1"

	output="$(tc -j chain get dev $h2 ingress chain 1)"
	check_err $? "Failed to get chain 1"

	echo $output | jq -e ".[] | select(.chain == 1)" &> /dev/null
	check_err $? "Unexpected output for chain 1"

	output="$(tc -j chain show dev $h2 ingress)"
	check_err $? "Failed to dump chains"

	echo $output | jq -e ".[] | select(.chain == 0)" &> /dev/null
	check_err $? "Can't find default chain in dump"

	echo $output | jq -e ".[] | select(.chain == 1)" &> /dev/null
	check_err $? "Can't find chain 1 in dump"

	tc chain del dev $h2 ingress
	check_err $? "Failed to destroy default chain"

	tc chain del dev $h2 ingress chain 1
	check_err $? "Failed to destroy chain 1"

	log_test "create destroy chain"
}

template_filter_fits()
{
	RET=0

	tc chain add dev $h2 ingress protocol ip \
		flower dst_mac 00:00:00:00:00:00/FF:FF:FF:FF:FF:FF &> /dev/null
	tc chain add dev $h2 ingress chain 1 protocol ip \
		flower src_mac 00:00:00:00:00:00/FF:FF:FF:FF:FF:FF &> /dev/null

	tc filter add dev $h2 ingress protocol ip pref 1 handle 1101 \
		flower dst_mac $h2mac action drop
	check_err $? "Failed to insert filter which fits template"

	tc filter add dev $h2 ingress protocol ip pref 1 handle 1102 \
		flower src_mac $h2mac action drop &> /dev/null
	check_fail $? "Incorrectly succeeded to insert filter which does not template"

	tc filter add dev $h2 ingress chain 1 protocol ip pref 1 handle 1101 \
		flower src_mac $h2mac action drop
	check_err $? "Failed to insert filter which fits template"

	tc filter add dev $h2 ingress chain 1 protocol ip pref 1 handle 1102 \
		flower dst_mac $h2mac action drop &> /dev/null
	check_fail $? "Incorrectly succeeded to insert filter which does not template"

	tc filter del dev $h2 ingress chain 1 protocol ip pref 1 handle 1102 \
		flower &> /dev/null
	tc filter del dev $h2 ingress chain 1 protocol ip pref 1 handle 1101 \
		flower &> /dev/null

	tc filter del dev $h2 ingress protocol ip pref 1 handle 1102 \
		flower &> /dev/null
	tc filter del dev $h2 ingress protocol ip pref 1 handle 1101 \
		flower &> /dev/null

	tc chain del dev $h2 ingress chain 1
	tc chain del dev $h2 ingress

	log_test "template filter fits"
}

setup_prepare()
{
	h1=${NETIFS[p1]}
	h2=${NETIFS[p2]}
	h1mac=$(mac_get $h1)
	h2mac=$(mac_get $h2)

	vrf_prepare

	h1_create
	h2_create
}

cleanup()
{
	pre_cleanup

	h2_destroy
	h1_destroy

	vrf_cleanup
}

check_tc_chain_support

trap cleanup EXIT

setup_prepare
setup_wait

tests_run

tc_offload_check
if [[ $? -ne 0 ]]; then
	log_info "Could not test offloaded functionality"
else
	tcflags="skip_sw"
	tests_run
fi

exit $EXIT_STATUS

Filemanager

Name Type Size Permission Actions
Makefile File 2.94 KB 0644
bridge_fdb_learning_limit.sh File 5.8 KB 0755
bridge_igmp.sh File 14.71 KB 0755
bridge_locked_port.sh File 9.25 KB 0755
bridge_mdb.sh File 45.15 KB 0755
bridge_mdb_host.sh File 1.66 KB 0755
bridge_mdb_max.sh File 29.98 KB 0755
bridge_mdb_port_down.sh File 2.24 KB 0755
bridge_mld.sh File 16.17 KB 0755
bridge_port_isolation.sh File 2.32 KB 0755
bridge_sticky_fdb.sh File 1.13 KB 0755
bridge_vlan_aware.sh File 4.2 KB 0755
bridge_vlan_mcast.sh File 16.74 KB 0755
bridge_vlan_unaware.sh File 1.65 KB 0755
custom_multipath_hash.sh File 9.8 KB 0755
devlink_lib.sh File 12.81 KB 0644
dual_vxlan_bridge.sh File 11.21 KB 0755
fib_offload_lib.sh File 24.57 KB 0644
gre_custom_multipath_hash.sh File 12.51 KB 0755
gre_inner_v4_multipath.sh File 7.55 KB 0755
gre_inner_v6_multipath.sh File 7.66 KB 0755
gre_multipath.sh File 6.29 KB 0755
gre_multipath_nh.sh File 8.1 KB 0755
gre_multipath_nh_res.sh File 8.25 KB 0755
ip6_forward_instats_vrf.sh File 3.04 KB 0755
ip6gre_custom_multipath_hash.sh File 12.77 KB 0755
ip6gre_flat.sh File 1.18 KB 0755
ip6gre_flat_key.sh File 1.24 KB 0755
ip6gre_flat_keys.sh File 1.3 KB 0755
ip6gre_hier.sh File 1.27 KB 0755
ip6gre_hier_key.sh File 1.33 KB 0755
ip6gre_hier_keys.sh File 1.39 KB 0755
ip6gre_inner_v4_multipath.sh File 7.77 KB 0755
ip6gre_inner_v6_multipath.sh File 7.88 KB 0755
ip6gre_lib.sh File 15.75 KB 0644
ipip_flat_gre.sh File 838 B 0755
ipip_flat_gre_key.sh File 860 B 0755
ipip_flat_gre_keys.sh File 886 B 0755
ipip_hier_gre.sh File 887 B 0755
ipip_hier_gre_key.sh File 910 B 0755
ipip_hier_gre_keys.sh File 938 B 0755
ipip_lib.sh File 8.34 KB 0644
lib.sh File 41.63 KB 0644
lib_sh_test.sh File 3.57 KB 0755
local_termination.sh File 14.42 KB 0755
min_max_mtu.sh File 4.74 KB 0755
mirror_gre.sh File 2.9 KB 0755
mirror_gre_bound.sh File 5.51 KB 0755
mirror_gre_bridge_1d.sh File 4.12 KB 0755
mirror_gre_bridge_1d_vlan.sh File 2.37 KB 0755
mirror_gre_bridge_1q.sh File 3.97 KB 0755
mirror_gre_bridge_1q_lag.sh File 7.02 KB 0755
mirror_gre_changes.sh File 5.17 KB 0755
mirror_gre_flower.sh File 2.61 KB 0755
mirror_gre_lag_lacp.sh File 7.48 KB 0755
mirror_gre_lib.sh File 3.65 KB 0644
mirror_gre_neigh.sh File 2.08 KB 0755
mirror_gre_nh.sh File 2.53 KB 0755
mirror_gre_topo_lib.sh File 3.45 KB 0644
mirror_gre_vlan.sh File 1.36 KB 0755
mirror_gre_vlan_bridge_1q.sh File 8.46 KB 0755
mirror_lib.sh File 3.72 KB 0644
mirror_topo_lib.sh File 2.73 KB 0644
mirror_vlan.sh File 1.86 KB 0755
no_forwarding.sh File 5.52 KB 0755
pedit_dsfield.sh File 6.69 KB 0755
pedit_ip.sh File 4.41 KB 0755
pedit_l4port.sh File 4.46 KB 0755
q_in_vni.sh File 10.71 KB 0755
q_in_vni_ipv6.sh File 10.87 KB 0755
router.sh File 7.32 KB 0755
router_bridge.sh File 3.97 KB 0755
router_bridge_1d.sh File 5.1 KB 0755
router_bridge_1d_lag.sh File 9.3 KB 0755
router_bridge_lag.sh File 6.82 KB 0755
router_bridge_pvid_vlan_upper.sh File 3.5 KB 0755
router_bridge_vlan.sh File 5.46 KB 0755
router_bridge_vlan_upper.sh File 3.92 KB 0755
router_bridge_vlan_upper_pvid.sh File 3.7 KB 0755
router_broadcast.sh File 5.02 KB 0755
router_mpath_nh.sh File 10.73 KB 0755
router_mpath_nh_lib.sh File 3.2 KB 0644
router_mpath_nh_res.sh File 12.71 KB 0755
router_mpath_seed.sh File 7.37 KB 0755
router_multicast.sh File 14.6 KB 0755
router_multipath.sh File 7.07 KB 0755
router_nh.sh File 3.31 KB 0755
router_vid_1.sh File 3.52 KB 0755
sch_ets.sh File 745 B 0755
sch_ets_core.sh File 7.33 KB 0644
sch_ets_tests.sh File 4.09 KB 0644
sch_red.sh File 11.14 KB 0755
sch_tbf_core.sh File 4.77 KB 0644
sch_tbf_ets.sh File 118 B 0755
sch_tbf_etsprio.sh File 1.37 KB 0644
sch_tbf_prio.sh File 118 B 0755
sch_tbf_root.sh File 496 B 0755
skbedit_priority.sh File 3.87 KB 0755
tc_actions.sh File 9.3 KB 0755
tc_chains.sh File 4.83 KB 0755
tc_common.sh File 710 B 0644
tc_flower.sh File 21.24 KB 0755
tc_flower_cfm.sh File 4.85 KB 0755
tc_flower_l2_miss.sh File 9.13 KB 0755
tc_flower_port_range.sh File 7.35 KB 0755
tc_flower_router.sh File 3.02 KB 0755
tc_mpls_l2vpn.sh File 5.03 KB 0755
tc_police.sh File 11.75 KB 0755
tc_shblocks.sh File 2.68 KB 0755
tc_tunnel_key.sh File 3.71 KB 0755
tc_vlan_modify.sh File 3.17 KB 0755
tsn_lib.sh File 5.47 KB 0644
vxlan_asymmetric.sh File 17.55 KB 0755
vxlan_asymmetric_ipv6.sh File 16.03 KB 0755
vxlan_bridge_1d.sh File 20.4 KB 0755
vxlan_bridge_1d_ipv6.sh File 21.31 KB 0755
vxlan_bridge_1d_port_8472.sh File 172 B 0755
vxlan_bridge_1d_port_8472_ipv6.sh File 188 B 0755
vxlan_bridge_1q.sh File 22.91 KB 0755
vxlan_bridge_1q_ipv6.sh File 24.35 KB 0755
vxlan_bridge_1q_port_8472.sh File 172 B 0755
vxlan_bridge_1q_port_8472_ipv6.sh File 188 B 0755
vxlan_reserved.sh File 7.23 KB 0755
vxlan_symmetric.sh File 18.05 KB 0755
vxlan_symmetric_ipv6.sh File 18.31 KB 0755
Filemanager